/*
** server.c -- a stream socket server demo
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>
#include "KazaTable.h"

KazaTable thetable;
int clientCount = 25;

void log ( char * msg )
{
	printf("--------------------------\n");
	printf("-------------->%s\n" , msg);
	printf("--------------------------\n");
}

int startsWith ( char * main , char* prefix)
{
	if ( (main == NULL) || (prefix == NULL ))
		return -1;
	
	unsigned int i = 0 ;
	
	for (  i = 0 ;i <strlen(prefix) ; i++ )
	{
		if ( main[i] != prefix[i])
		{
			
			return i;
		}
		
	}
	
	return 1;
}

void publishHandler ( char * str )
{
	char * key =  strtok ( str , ":");
	if ( key != NULL )
	{
		char * fileName = strtok(NULL  , ":" );
		if ( fileName != NULL )
		{
			char * addr = strtok(NULL  , ":" );
			if ( addr!= NULL  )
			{
				char * port = strtok( NULL ,":" );
						
				thetable.add( key, fileName, addr, port);
				printf ("key is :  %s \n" ,key );
				printf ("filename is %s\n " , fileName  );
				printf ("address is %s \n" , addr);
				printf ("The port is %s \n" , port);
			}
		}
	}
	else
	{
		printf ("The str is %s\n" , str);
	}
}

void searchHandler (char * str,int fd )
{
	VECTOR result = thetable.find(str);
	
	int end = result.size();
	int size;
	STRING forsend;
	
	send(fd, &end, sizeof(int), 0);
	
	for(int i = 0; i < end; i++)
	{
		forsend = result[i].getKey();
		size = forsend.size();
		send(fd, &size, sizeof(int), 0);
		send(fd, forsend.c_str(), size, 0);
				
		forsend = result[i].getFileName();
		size = forsend.size();
		send(fd, &size, sizeof(int), 0);
		send(fd, forsend.c_str(), size, 0);
				
		forsend = result[i].getIPAddress();
		size = forsend.size();
		send(fd, &size, sizeof(int), 0);
		send(fd, forsend.c_str(), size, 0);
				
		forsend = result[i].getPort();
		size = forsend.size();
		send(fd, &size, sizeof(int), 0);
		send(fd, forsend.c_str(), size, 0);		
	}
}

void * clientHandler ( void * args)
{
	int fd1 = int(args);
	while (1)
	{
		char buf [1000] = ""  ;
		int bytes =  recv(fd1 , buf,1000 , 0);
	
		if ( bytes == -1 )
		{
			perror("recv");
		}

	
		if ( startsWith ( buf , "publish") == 1 )
		{
			//log("calling ;;;");
			publishHandler ( buf + 8);
		
			log ("One publish has been received");			
		}
		else if (startsWith( buf,"search") ==1 )
		{
		
			printf ("The buffer is : %s. \n" , buf);
			searchHandler ( buf+7 ,fd1);
			//log ("One search has been received");
		}
		else if ( startsWith (buf , "end:"))
		{
			clientCount++;
			break;
		}	
	}
	
	log ("---------------------------end of the connection\n");
	close(fd1);
	
	return NULL;
}

	
int main(void)
{
	
	
	int myPort  = 5000;
	char validity;
	int sockfd, fd; // listen on sock_fd, new connection on new_fd
	struct sockaddr_in my_addr; // my address information
	struct sockaddr_in their_addr; // connector's address information
//	int sin_size;
//	int yes=1;	
	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	my_addr.sin_family = AF_INET; // host byte order
	my_addr.sin_port = htons(myPort); // short, network byte order
	my_addr.sin_addr.s_addr = INADDR_ANY; // automatically fill with my IP
	memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct
	if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr))	== -1) {
		perror("bind");
		exit(1);
	}
//	log("Listen on the socket");
	if (listen(sockfd, clientCount) == -1) {
		perror("listen");
		exit(1);
	}
	log ("Server start listening ");
	while(1) { // main accept() loop
		socklen_t t = sizeof(struct sockaddr_in);
//		log("Waiting for arrived clients.");
		if ((fd = accept(sockfd, (struct sockaddr *)&their_addr,&t)) == -1) {
			perror("accept");
			continue;
		}

		if( clientCount > 0) 
		{
			clientCount--;

			validity = 1;
			
			send( fd, &validity, 1, 0);
			
			printf("server: got connection from %s\n",inet_ntoa(their_addr.sin_addr));
			pthread_t client ;
		//	log("The file descriptor is ---------- "  fd);
		//	printf ( "File decsriptor is : %d \n " , fd );
		//		fd1 = fd ; 
		//	char * clientFD = fd + "dd";
		
			pthread_create(&client , NULL, &clientHandler , (void *)fd );
		}
		else 
		{
			validity = 0;
			
			send ( fd, &validity, 1, 0);
			close (fd);
		}
	
	}
	return 0;
}
